﻿Imports System.Data.SqlClient
Imports System.Windows.Forms

Public Class 產品庫存表
    Public Sub Set_生產庫存清單()
        ' 執行 Set_物料組合件明細表() 即會更新一次點名清單
        Dim ds1 As New DataSet : DataGridView1.DataSource = Nothing : ds1.Clear()
        SetDGV樣式值(DataGridView1)
        SQL_生產庫存明細表_讀取()
        da.Fill(ds1) : DataGridView1.DataSource = ds1.Tables(0) : conn.Close()
        ' 決定可點擊項目
        DataGridView1.Columns(0).FillWeight = 20
        DataGridView1.Columns(1).FillWeight = 110
        DataGridView1.Columns(2).FillWeight = 40
        DataGridView1.Columns(3).Visible = False

        For i As Integer = 0 To DataGridView1.Rows.Count - 1
            DataGridView1.Rows(i).Cells("項次").Value = i + 1
            ' 以下是為了不讓點擊點名狀況出現空值而產生錯誤 ['DBNull' 和 類型 'Boolean' 的運算子 '=' 未定義。']
            If IsDBNull(DataGridView1.Rows(i).Cells("產品").Value) Then
                DataGridView1.Rows(i).Cells("產品").Value = False
            End If
        Next
    End Sub
    Public Sub Set_搜尋庫存清單()
        ' 執行 Set_物料組合件明細表() 即會更新一次點名清單
        Dim ds1 As New DataSet : DataGridView1.DataSource = Nothing : ds1.Clear()
        SetDGV樣式值(DataGridView1)
        SQL_搜尋庫存明細表_讀取(txtKeyword_tb.Text)
        da.Fill(ds1) : DataGridView1.DataSource = ds1.Tables(0) : conn.Close()
        ' 決定可點擊項目
        DataGridView1.Columns(0).FillWeight = 20
        DataGridView1.Columns(1).FillWeight = 110
        DataGridView1.Columns(2).FillWeight = 40
        DataGridView1.Columns(3).Visible = False

        For i As Integer = 0 To DataGridView1.Rows.Count - 1
            DataGridView1.Rows(i).Cells("項次").Value = i + 1
            ' 以下是為了不讓點擊點名狀況出現空值而產生錯誤 ['DBNull' 和 類型 'Boolean' 的運算子 '=' 未定義。']
            If IsDBNull(DataGridView1.Rows(i).Cells("產品").Value) Then
                DataGridView1.Rows(i).Cells("產品").Value = False
            End If
        Next
    End Sub
    Private Sub InitializeForm()
        ' 表單畫面初始化
        Me.MdiParent = OW_ERP_SYS  ' 設定此表 MDI父表單為Sh_To_ERP_SYS Form
        Me.WindowState = 0            ' 本表單顯示大小為常態
        Me.AutoScroll = True          ' 啟用表單自動滾動屏幕
        '隱藏用_pl.SendToBack()           ' 將用來隱藏控件的 Panel3放入底層
        MyMod.清單字體大小調整()
        DataGridView1.RowsDefaultCellStyle.Font = New System.Drawing.Font("微軟正黑體", 12)

        AddHandler txtKeyword_tb.KeyDown, AddressOf txtKeyword_tb_KeyDown
    End Sub
    Private Sub 生產庫存控制表_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        InitializeForm()
    End Sub
    Private Sub 生產庫存控制表_Shown(sender As Object, e As EventArgs) Handles MyBase.Shown
        Set_生產庫存清單()
    End Sub
    Private Sub 生產庫存控制表_Closed(sender As Object, e As EventArgs) Handles MyBase.Closed
        MyMod.虛擬桌面開啟()
    End Sub
    ' ↓↓---------------------- Set DataGridView 樣式相關功能 ----------------------↓↓
    Private Sub SetDGV樣式值(dgv As DataGridView)
        ' Set DataGridView 樣式值
        dgv.DataSource = Nothing
        dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing
        dgv.ColumnHeadersHeight = 25
        dgv.AllowUserToAddRows = False
        dgv.RowTemplate.Height = Get_DGV_Row_Height()
    End Sub

    Private Function Get_DGV_Row_Height() As Integer
        ' 用來決定DGV的每一Row高度，在於哪一個間距 CheckBox被按下
        If 小間距_ch.Checked = True And 中間距_ch.Checked = False And 大間距_ch.Checked = False Then : Return 25
        ElseIf 小間距_ch.Checked = False And 中間距_ch.Checked = True And 大間距_ch.Checked = False Then : Return 45
        ElseIf 小間距_ch.Checked = False And 中間距_ch.Checked = False And 大間距_ch.Checked = True Then : Return 65
        End If
        Return 45 ' Default value
    End Function
    ' ↓↓---------------------- DataGridView 間距設定相關功能 ----------------------↓↓
    Private Sub 間距_ch_CheckedChanged(sender As Object, e As EventArgs) Handles 小間距_ch.Click, 中間距_ch.Click, 大間距_ch.Click
        Dim 小間距 As Boolean = (sender Is 小間距_ch) : Dim 中間距 As Boolean = (sender Is 中間距_ch) : Dim 大間距 As Boolean = (sender Is 大間距_ch)
        小間距_ch.Checked = 小間距 : 中間距_ch.Checked = 中間距 : 大間距_ch.Checked = 大間距

        If 小間距 Then
            MyMod.間距設定存檔_1()
        ElseIf 中間距 Then
            MyMod.間距設定存檔_2()
        ElseIf 大間距 Then
            MyMod.間距設定存檔_3()
        End If
        Set_生產庫存清單()
    End Sub
    ' ↑↑---------------------- DataGridView 間距設定相關功能 ----------------------↑↑
    ' ↑↑---------------------- Set DataGridView 樣式相關功能 ----------------------↑↑
    Private Sub txtKeyword_tb_KeyDown(sender As Object, e As KeyEventArgs)
        If e.KeyCode = Keys.Enter Then
            ' 在此處插入當Enter鍵被按下時您想執行的代碼
            Set_搜尋庫存清單()
            查詢DGV中的關鍵字(DataGridView1, txtKeyword_tb)

            ' 如果您不希望在按下Enter鍵時換行或進行其他默認操作，可以添加以下代碼：
            e.Handled = True
            e.SuppressKeyPress = True
        End If
    End Sub

    ' ↓↓---------------------- 判斷重登 功能 ----------------------↓↓
    Private Sub 登入閒置控制_MouseMove(sender As Object, e As EventArgs) Handles MyBase.MouseMove
        timeNow = 0 : OW_ERP_SYS.Timer1.Enabled = False : OW_ERP_SYS.Timer1.Enabled = True
    End Sub
    Private Sub 登入閒置控制_KeyPress(sender As Object, e As EventArgs) Handles MyBase.KeyPress
        timeNow = 0 : OW_ERP_SYS.Timer1.Enabled = False : OW_ERP_SYS.Timer1.Enabled = True
    End Sub
    Private Sub 關鍵字_bt_Click(sender As Object, e As EventArgs) Handles 關鍵字_bt.Click
        Set_搜尋庫存清單()
        查詢DGV中的關鍵字(DataGridView1, txtKeyword_tb)
    End Sub
    ' ↑↑---------------------- 判斷重登 功能 ----------------------↑↑
End Class